#!/bin/bash
# Copyright (C) 2004-2013 Centro de Computacao Cientifica e Software Livre
# Departamento de Informatica - Universidade Federal do Parana - C3SL/UFPR
#
# This file is part of datasid
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
# USA.

# set PREFIX
export PREFIX="$(readlink -f "$(dirname $0)/../")"

# run datasid-common.sh
source "$(readlink -f "$(dirname $0)")/datasid-common.sh" || exit 2

if test -z "${PREFIX}"; then
    date +"%F %T - ERROR: Prefix not set."
    exit 2
fi

if test -z "${WEBSERVICE}"; then
    date +"%F %T - ERROR: Web service url not configured."
    exit 2
fi

url="--url=${WEBSERVICE}"

# Add a prefix to each non empty proxy information
test -n "${PROXY_HOST}" && phost="--phost=${phost}"
test -n "${PROXY_PORT}" && pport="--pport=${pport}"
test -n "${PROXY_USERNAME}" && puid="--puid=${puid}"
test -n "${PROXY_PASSWORD}" && ppasswd="--ppasswd=${ppasswd}"
proxy="${phost} ${pport} ${puid} ${ppasswd}"

interface=""
if test $(/sbin/route | grep default | wc -l) -gt 1; then
    getNetworkInterface
    interface="--nic=${interface}"
fi

${PREFIX}/bin/datasid-gsoap-client ${url} ${proxy} ${interface} $*
exit $?
