/* Copyright (C) 2004-2013 Centro de Computacao Cientifica e Software Livre
 * Departamento de Informatica - Universidade Federal do Parana - C3SL/UFPR
 *
 * This file is part of datasid
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
 * USA. */

/*---------------------------------------------------------------------------*/

#ifndef _H_XMLGENERATOR_H_
#define _H_XMLGENERATOR_H_

#include <libxml/encoding.h>
#include <libxml/xmlwriter.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MY_ENCODING "UTF-8"
#define STR_INI_SIZE 200

/* Error Flags */
#define MEM_ALLOC 1
#define CMD_RESULT 2
#define PERM_DENIED_CMD 4
#define ARGS 8
#define CREATE_XML_DOC 16
#define SAVE_XML_FILE 32
#define PARSE_COLLECT 64
#define DEBUG_ALL 127 /* Enables debug of all flags */
#define NO_DEBUG 0 /* Disables debug of all flags */
/* Print ERROR messages */
#define ERROR(fmt, args...) ( fprintf(stderr, fmt, ##args), \
                              fflush(stderr) )

/* Variable that stores the status of collect-parser running */
static char statusRunning = 0;

/*---------------------------------------------------------------------------*/

int generateXML(const char *, const char *);
int setErrorFlag(const char);
int unsetErrorFlag(const char);
int printErrorMsgs(const char);
static int allocString(char **, const int);
static int concatString(char **, const char *, const char *);
static char *nodeName(char *);
static char *attribData(const char *);
static int execCommand(const char *, char **);
static int parserXml(const char *, xmlTextWriterPtr *);

#endif
